/*----------------------------------------------------------------------------*/
/* Company : ADLINK                                                           */
/* Date    : 2011/02/24                                                       */
/*                                                                            */
/* This sample performs EEPROM read and write capability for PCI-7230.        */
/* There are two 16-bits EEPROM blocks to store user-defined constants.		  */
/* Parameters:																  */
/*				P7230_EEP_BLK_0												  */
/*				P7230_EEP_BLK_1												  */
/*----------------------------------------------------------------------------*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "dask.h"

int main(int argc, char **argv)
{
    I16 card, err;
    U16 card_num;
    U16 data_read = 0, data_write = 0x3343;
	U16	block = P7230_EEP_BLK_0;

    printf("The sample performs PCI-7230 EEPROM read/write.\n");

    printf("Card Number: ");
    scanf(" %hd", &card_num);
    card = Register_Card(PCI_7230, card_num);
    if(card<0){
        printf("Register_Card Error: %d\n", card);
        exit(1);
    }

	err = PCI_EEPROM_SaveData(card, block, data_write);
    if(err!=0){
        printf("PCI7230_ReadEEPROM Error: %d\n", err);
		Release_Card(card);
		exit(1);
    }

	err = PCI_EEPROM_LoadData(card, block, &data_read);
    if(err!=0){
        printf("PCI7230_ReadEEPROM Error: %d\n", err);
		Release_Card(card);
		exit(1);
    }
		
	printf("Read data: %x\n", data_read);

    printf("\nPress any key to exit...\n");
    getch();
    Release_Card(card);
    return 0;
}
