
// 7230intDlg.cpp : implementation file
//

#include "stdafx.h"
#include "7230int.h"
#include "7230intDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#define EXT_SIGNAL1_MESSAGE _T("EXT_SIG1")
#define EXT_SIGNAL2_MESSAGE _T("EXT_SIG2")

UINT WM_INT0 = ::RegisterWindowMessage(EXT_SIGNAL1_MESSAGE);
UINT WM_INT1 = ::RegisterWindowMessage(EXT_SIGNAL2_MESSAGE);

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// C7230intDlg dialog




C7230intDlg::C7230intDlg(I16 hCard, CWnd* pParent /*=NULL*/)
	: CDialog(C7230intDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_hCard = hCard;
	m_dwOutVal = 0x00000000;

	m_IntCount = m_IntCount2 = 0;
}

void C7230intDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(C7230intDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_REGISTERED_MESSAGE(WM_INT0, OnExtSIGInterrupt1)
	ON_REGISTERED_MESSAGE(WM_INT1, OnExtSIGInterrupt2)
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BT_OUTPUT, &C7230intDlg::OnOutput)
END_MESSAGE_MAP()


// C7230intDlg message handlers

BOOL C7230intDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_IntCount = m_IntCount2 = 0;

	DIO_INT1_EventMessage (m_hCard, INT1_EXT_SIGNAL, this->m_hWnd, WM_INT0, NULL);
	DIO_INT2_EventMessage (m_hCard, INT2_EXT_SIGNAL, this->m_hWnd, WM_INT1, NULL);

	DO_WritePort(m_hCard, 0, m_dwOutVal);



	return TRUE;  // return TRUE  unless you set the focus to a control
}

void C7230intDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void C7230intDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR C7230intDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void C7230intDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	DIO_INT1_EventMessage (m_hCard, INT1_DISABLE, this->m_hWnd, NULL, NULL);
	DIO_INT2_EventMessage (m_hCard, INT2_DISABLE, this->m_hWnd, NULL, NULL);
	DO_WritePort(m_hCard, 0, 0x0);
}


void C7230intDlg::OnOutput()
{
	// TODO: Add your control notification handler code here
	DO_WritePort(m_hCard, 0, 0x3);
	DO_WritePort(m_hCard, 0, 0x0);
}

LRESULT C7230intDlg::OnExtSIGInterrupt1(WPARAM wParam, LPARAM lParam)
{
	// do something useful
	CString strTemp;

	m_IntCount ++;

	strTemp.Format( TEXT("INT1 Count = %d"), m_IntCount );
	SetDlgItemText( IDC_STATIC_05, strTemp );

	return (LRESULT) 0;
}

LRESULT C7230intDlg::OnExtSIGInterrupt2(WPARAM wParam, LPARAM lParam)
{
	// do something useful
	CString strTemp;

	m_IntCount2 ++;

	strTemp.Format( TEXT("INT2 Count = %d"), m_IntCount2 );
	SetDlgItemText( IDC_STATIC_06, strTemp );

	return (LRESULT) 0;
}
