
// 7396IntDlg.cpp : implementation file
//

#include "stdafx.h"
#include "7396Int.h"
#include "7396IntDlg.h"
#include "SetupDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

U32 gInBuffer[32768], gOutBuffer[32768];
HANDLE ghIntEvent[2];

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// C7396IntDlg dialog




C7396IntDlg::C7396IntDlg(CWnd* pParent /*=NULL*/)
	: CDialog(C7396IntDlg::IDD, pParent)
	, m_nCardIdx(-1)
	, m_nSampleCount(-1)
	, m_nSampleRate(-1)
	, m_hCard(-1)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_nC1=10; m_nC2=10;
}

void C7396IntDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(C7396IntDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
//	ON_STN_CLICKED(IDC_STATIC_07, &C7396IntDlg::OnStnClickedStatic07)
ON_WM_DESTROY()
ON_BN_CLICKED(IDC_BT_SETUP, &C7396IntDlg::OnSetup)
ON_BN_CLICKED(IDC_BT_TRIGGER, &C7396IntDlg::OnTrigger)
ON_WM_CTLCOLOR()
END_MESSAGE_MAP()


// C7396IntDlg message handlers

BOOL C7396IntDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void C7396IntDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void C7396IntDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR C7396IntDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void C7396IntDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	int i;

	if( m_hCard >= 0 )
	{
		DIO_SetDualInterrupt(m_hCard, INT1_DISABLE, INT2_DISABLE, ghIntEvent);

		for (i=0; i<2; i++) 
		{
			if(ghIntEvent[i])
				ResetEvent(ghIntEvent[i]);
		}
		

		Release_Card( m_hCard ); m_hCard = -1;
	}
}

void C7396IntDlg::OnSetup()
{
	// TODO: Add your control notification handler code here
	CSetupDlg setupDlg;
	INT_PTR nResponse;
	CString strTemp;
	int i, k;

	nResponse = setupDlg.DoModal();
	if (nResponse == IDOK)
	{
		if( m_nCardIdx != setupDlg.m_nCardIdx )
		{
			if(  m_hCard != -1 )
			{
				Release_Card( m_hCard ); 
				m_hCard = -1;
			}

			m_nCardIdx = setupDlg.m_nCardIdx;
		}


		if( m_hCard == -1 )
		{
			if ((m_hCard = Register_Card(PCI_7396, m_nCardIdx)) < 0) 
			{
				strTemp.Format( TEXT("Register_Card Error = %d"), m_hCard);
				AfxMessageBox( strTemp );
			
				EndDialog(IDCANCEL);
				return;
			}
		}

		m_nSampleCount = setupDlg.m_nSampleCount;
		m_nSampleRate = setupDlg.m_nSampleRate;

		for ( i=0, k=0; i<m_nSampleCount; i++)
		{
			gOutBuffer[i]=k;
			k ++;
			if (k>255) k=0;

			gInBuffer[i]=0;
		}


		DIO_PortConfig(m_hCard, Channel_P1A, INPUT_PORT);
		DIO_PortConfig(m_hCard, Channel_P2A, OUTPUT_PORT);
			
		DIO_SetDualInterrupt(m_hCard, INT1_DISABLE, INT2_TIMER_COUNTER, ghIntEvent);
		m_nC2 = 2000000/(m_nSampleRate*m_nC1);

		GetDlgItem(IDC_BT_TRIGGER)->EnableWindow( TRUE );

	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}
}

void C7396IntDlg::OnTrigger()
{
	// TODO: Add your control notification handler code here
	int i, k;
	CString strTemp;
	CString strLine1, strLine2, strLine3, strLine4, strLine5;

	CTR_Setup(m_hCard, 1, RATE_GENERATOR, m_nC1, BIN);
	CTR_Setup(m_hCard, 2, RATE_GENERATOR, m_nC2, BIN);
	
	k=0; i=0; 
	
	while ( k < m_nSampleCount )
	{
		if (WaitForSingleObject(ghIntEvent[1], 4000) == WAIT_OBJECT_0) 
		{
			strTemp.Format( TEXT("INT2 Count = %d "), k+1);
			SetDlgItemText( IDC_STATIC_06, strTemp );

			DO_WritePort( m_hCard, Channel_P2A, gOutBuffer[k]);
			DI_ReadPort( m_hCard, Channel_P1A, &(gInBuffer[k]) );

			k++;
		}
	}
	
	CTR_Setup( m_hCard, 1, RATE_GENERATOR, 0, BIN);
	CTR_Setup( m_hCard, 2, RATE_GENERATOR, 0, BIN);

	GetDlgItem(IDC_STATIC_07)->ShowWindow( SW_SHOW );

	strLine1.Empty(); /// clear strLine1
	strLine2.Empty(); /// clear strLine2
	strLine3.Empty(); /// clear strLine3
	strLine4.Empty(); /// clear strLine4
	strLine5.Empty(); /// clear strLine5

	for ( i=0; i<m_nSampleCount; i++) 
	{
		strTemp.Format( TEXT("%d, "), gInBuffer[i] );

		if(i<10) 
		{
			strLine1 += strTemp;
		}
		if(i>=10 && i<20) 
		{
			strLine2 += strTemp;
		}
		if(i>=20 && i<30)
		{
			strLine3 += strTemp;
		}
		if (i>=30 && i<40)
		{
			strLine4 += strTemp;
		}
		if (i>=40 && i<50)
		{
			strLine5 += strTemp;
		}
	}

	if( !strLine1.IsEmpty() )
		SetDlgItemText( IDC_STATIC_LINE1, strLine1 );

	if( !strLine2.IsEmpty() )
		SetDlgItemText( IDC_STATIC_LINE2, strLine2 );

	if( !strLine3.IsEmpty() )
		SetDlgItemText( IDC_STATIC_LINE3, strLine3 );

	if( !strLine4.IsEmpty() )
		SetDlgItemText( IDC_STATIC_LINE4, strLine4 );

	if( !strLine5.IsEmpty() )
		SetDlgItemText( IDC_STATIC_LINE5, strLine5 );
}

HBRUSH C7396IntDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	// TODO:  Change any attributes of the DC here
	if ( pWnd->GetDlgCtrlID() == IDC_STATIC_04 )
		pDC->SetTextColor(RGB(255,0,0)); 

	// TODO:  Return a different brush if the default is not desired
	return hbr;
}
